﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
' Supporting Android StarPRNT SDK Version 5.3.0
'    http://www.starmicronics.com/pages/StarPRNT-SDK
' StarPort and related modules provide B4A a wrapper to the Star SDK.
'
' 1. Be sure StarSDK files are found here: D:\ODPMOBILE\B4A\AdditionalLibraries
'    a) StarIOPort3.1.jar
'    b) starioextension.jar
' 2. Add these lines to Project Attributes in Main:
'    #AdditionalJar: StarIOPort3.1
'    #AdditionalJar: starioextension
' 3. Add this line to your manifest (menu: Project / Manifest Editor)
'    AddPermission(android.permission.BLUETOOTH)
' 4. Add existing modules from here: D:\ODPMOBILE\B4A\SharedModules
'    a) StarPort.bas
'    b) StarCommandBuilder.bas
'    c) StarAlignmentPosition.bas
'    d) StarBarcodeSymbology.bas
'    e) StarBarcodeWidth.bas
'    f) StarBitmapConverterRotation.bas
'    g) StarBlackMarkType.bas
'    h) StarCharacterCode.bas
'    i) StarCodePage.bas
'    j) StarCutPaper.bas
'    k) StarEmulation.bas
'    l) StarFontStyle.bas
'    m) StarInitializationType.bas
'    n) StarInternationalType.bas
'    o) StarPDF417SecurityLevel.bas
'    p) StarPortInfo.bas
'    q) StarPrinterStatus.bas
'    r) StarQRCodeLevel.bas
'    s) StarQRCodeModel.bas
'    t) StarSoundChannel.bas
' 5. On Libraries tab add ByteConverter
' 6. You are now ready to write code and use the SDK.
' 7. Review Star SDK documentation found here: D:\ODPMOBILE\B4A\Documentation
'    a) StarIO_StarPRNT_Android_SDK.pdf
'    b) StarIO_ESCPOS_PortablePrinter_Android_SDK.pdf
' 
' This wrapper class was designed and written by Lee Gillie, CCP - April 28, 2017
'
' __Date__	_Who_	__Description_____________________________________________________________
' 4/28/17	Lee		New wrapper for StarPRNT SDK supporting SM-T300i (et. al.) model printer

Sub Class_Globals
	Private StarIO As JavaObject
	Private port As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	StarIO.InitializeStatic("com.starmicronics.stario.StarIOPort" )
End Sub

Public Sub Open(portName As String, portSettings As String, timeoutMilliseconds As Int) As Boolean
	port = StarIO.RunMethod("getPort",Array As Object(portName,portSettings,timeoutMilliseconds))
	Return True
End Sub

Public Sub Close()
	StarIO.RunMethod("releasePort",Array As Object(port))
End Sub

Public Sub SearchPrinter( target As String) As List
	Dim wl As List
	Dim al As List
	wl.Initialize
	al = StarIO.RunMethod("searchPrinter",Array As Object(target))
	For i = 0 To al.Size-1
		Dim spi As StarPortInfo
		spi.Initialize(al.Get(i))
		wl.Add(spi)
	Next
	Return wl	
End Sub

Public Sub ReadPort(buffer() As Byte, offset As Int, size As Int) As Int
	Dim bytesRead As Int = port.RunMethod("readPort",Array As Object(buffer,offset,size) )
	Return bytesRead
End Sub

Public Sub WritePort(buffer() As Byte, offset As Int, size As Int)
	port.RunMethod("writePort",Array As Object(buffer,offset,size) )
End Sub

Public Sub RetreiveStatus As StarPrinterStatus
	Dim sps As StarPrinterStatus
	sps.Initialize(port.RunMethod("retreiveStatus",Null))
	Return sps
End Sub

Public Sub BeginCheckedBlock As StarPrinterStatus
	Dim sps As StarPrinterStatus
	sps.Initialize(port.RunMethod("beginCheckedBlock",Null))
	Return sps	
	End Sub

Public Sub EndCheckedBlock As StarPrinterStatus
	Dim sps As StarPrinterStatus
	sps.Initialize(port.RunMethod("endCheckedBlock",Null))
	Return sps	
End Sub

Public Sub setEndCheckedBlockTimeoutMillis( endCheckedBlockTimeoutMillis As Int)
	port.RunMethod("setEndCheckedBlockTimeoutMillis",Array As Object(endCheckedBlockTimeoutMillis))
End Sub

Public Sub getFirmwareInformation() As Map
'	Dim jo As JavaObject
'	jo = port.RunMethod("getFirmwareInformation",Null)
'	Dim siz As Int
'	siz = jo.GetField("size")
	
	Dim mp As Map
	mp.Initialize
	Return mp
End Sub

Public Sub getStarIOVersion() As String
	Dim value As String
	value = port.RunMethod("getStarIOVersion",Null)
	Return value
End Sub
